% -*- MATLAB -*-
% Time-stamp: "2015-08-05 20:12:48 user"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function v = norm( a, p )

  [row,col] = size( a );

  v = exfloat();

  %------------------------------
  % a is a vector
  %------------------------------
  if( row == 1)

    if p == 1

      for n=1:col

        x = exfloat( a(n) );

        x.num(1) = bitand( x.num(1), exfloat.EXP_MASK);

        exflib_float_add(v.num, v.num, x.num, exfloat.precision64);

      end

      return

    end

    if p == 2

      x2  = exfloat();
      sum = exfloat();

      for n=1:col

        x = exfloat( a(n) );
        exflib_float_mul(x2.num, x.num, x.num, exfloat.precision64);
        exflib_float_add(sum.num, sum.num, x2.num, exfloat.precision64);

      end

      % temporary storage
      worksize = uint32( (exfloat.size64 + 1)*5 );
      work = zeros(worksize,1, 'uint64');

      exflib_float_sqrt(v.num, sum.num, exfloat.precision64, work);

      return

    end

    if p == 'Inf'

      return

    end

  end

  %------------------------------
  % a is matrix, or other norms
  %------------------------------
  fprintf('%d-norm is Not yet implemented\n', p);

end

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
